Gentoo Forums
Gentoo Forums
Gentoo Forums
Quick Search: in
webkit-gtk fails to build
View unanswered posts
View posts from last 24 hours

 
Reply to topic    Gentoo Forums Forum Index Portage & Programming
View previous topic :: View next topic  
Author Message
Princess Nell
l33t
l33t


Joined: 15 Apr 2005
Posts: 738

PostPosted: Sun Dec 10, 2017 9:28 pm    Post subject: webkit-gtk fails to build Reply with quote

I had to update icu from 58.2-r1 to 60.1, which caused rebuilds for a number of packages. One that now doesn't build anymore is webkit-gtk-2.4.11-r200. Any ideas what's wrong here? This is under the new 17.0 desktop profile.

Code:

mv -f Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSContextRef.Tpo Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSContextRef.Plo
/bin/sh ./libtool  --tag=CXX   --mode=compile x86_64-pc-linux-gnu-g++ -DHAVE_CONFIG_H -I.  -Wall -W -Wcast-align -Wchar-subscripts -Wreturn-type -Wformat -Wformat-security -Wno-format-y2k -Wundef -Wmissing-format-attribute -Wpointer-arith -Wwrite-strings -Wno-unused-parameter -Wno-parentheses -fno-exceptions -DBUILDING_CAIRO__ -DBUILDING_GTK__   -I./Source -I./Source/JavaScriptCore -I./Source/JavaScriptCore/API -I./Source/JavaScriptCore/ForwardingHeaders -I./Source/JavaScriptCore/assembler -I./Source/JavaScriptCore/bindings -I./Source/JavaScriptCore/bytecode -I./Source/JavaScriptCore/bytecompiler -I./Source/JavaScriptCore/debugger -I./Source/JavaScriptCore/dfg -I./Source/JavaScriptCore/disassembler -I./Source/JavaScriptCore/ftl -I./Source/JavaScriptCore/heap -I./Source/JavaScriptCore/inspector -I./Source/JavaScriptCore/inspector/agents -I./Source/JavaScriptCore/interpreter -I./Source/JavaScriptCore/jit -I./Source/JavaScriptCore/llint -I./Source/JavaScriptCore/parser -I./Source/JavaScriptCore/profiler -I./Source/JavaScriptCore/runtime -I./Source/JavaScriptCore/tools -I./Source/JavaScriptCore/yarr -I./DerivedSources/JavaScriptCore -I./Source/WTF  -fno-omit-frame-pointer -fno-tree-dce  -fno-rtti  -pthread -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include  -I/usr/include  -O2 -march=native -pipe -fomit-frame-pointer -pthread -std=c++11 -Wno-c++11-compat   -MT Source/JavaScriptCore/API/libjavascriptcoregtk_1_0_la-JSStringRef.lo -MD -MP -MF Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSStringRef.Tpo -c -o Source/JavaScriptCore/API/libjavascriptcoregtk_1_0_la-JSStringRef.lo `test -f 'Source/JavaScriptCore/API/JSStringRef.cpp' || echo './'`Source/JavaScriptCore/API/JSStringRef.cpp
libtool: compile:  x86_64-pc-linux-gnu-g++ -DHAVE_CONFIG_H -I. -Wall -W -Wcast-align -Wchar-subscripts -Wreturn-type -Wformat -Wformat-security -Wno-format-y2k -Wundef -Wmissing-format-attribute -Wpointer-arith -Wwrite-strings -Wno-unused-parameter -Wno-parentheses -fno-exceptions -DBUILDING_CAIRO__ -DBUILDING_GTK__ -I./Source -I./Source/JavaScriptCore -I./Source/JavaScriptCore/API -I./Source/JavaScriptCore/ForwardingHeaders -I./Source/JavaScriptCore/assembler -I./Source/JavaScriptCore/bindings -I./Source/JavaScriptCore/bytecode -I./Source/JavaScriptCore/bytecompiler -I./Source/JavaScriptCore/debugger -I./Source/JavaScriptCore/dfg -I./Source/JavaScriptCore/disassembler -I./Source/JavaScriptCore/ftl -I./Source/JavaScriptCore/heap -I./Source/JavaScriptCore/inspector -I./Source/JavaScriptCore/inspector/agents -I./Source/JavaScriptCore/interpreter -I./Source/JavaScriptCore/jit -I./Source/JavaScriptCore/llint -I./Source/JavaScriptCore/parser -I./Source/JavaScriptCore/profiler -I./Source/JavaScriptCore/runtime -I./Source/JavaScriptCore/tools -I./Source/JavaScriptCore/yarr -I./DerivedSources/JavaScriptCore -I./Source/WTF -fno-omit-frame-pointer -fno-tree-dce -fno-rtti -pthread -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include -O2 -march=native -pipe -fomit-frame-pointer -pthread -std=c++11 -Wno-c++11-compat -MT Source/JavaScriptCore/API/libjavascriptcoregtk_1_0_la-JSStringRef.lo -MD -MP -MF Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSStringRef.Tpo -c Source/JavaScriptCore/API/JSStringRef.cpp  -fPIC -DPIC -o Source/JavaScriptCore/API/.libs/libjavascriptcoregtk_1_0_la-JSStringRef.o
Source/JavaScriptCore/API/JSStringRef.cpp: In function ‘OpaqueJSString* JSStringCreateWithCharacters(const JSChar*, size_t)’:
Source/JavaScriptCore/API/JSStringRef.cpp:40:50: error: invalid conversion from ‘const JSChar* {aka const short unsigned int*}’ to ‘const UChar* {aka const char16_t*}’ [-fpermissive]
     return OpaqueJSString::create(chars, numChars).leakRef();
                                                  ^
In file included from Source/JavaScriptCore/API/JSStringRef.cpp:31:0:
Source/JavaScriptCore/API/OpaqueJSString.h:49:39: note:   initializing argument 1 of ‘static WTF::PassRefPtr<OpaqueJSString> OpaqueJSString::create(const UChar*, unsigned int)’
     static PassRefPtr<OpaqueJSString> create(const UChar* characters, unsigned length)
                                       ^~~~~~
Source/JavaScriptCore/API/JSStringRef.cpp: In function ‘OpaqueJSString* JSStringCreateWithCharactersNoCopy(const JSChar*, size_t)’:
Source/JavaScriptCore/API/JSStringRef.cpp:65:83: error: invalid conversion from ‘const JSChar* {aka const short unsigned int*}’ to ‘const UChar* {aka const char16_t*}’ [-fpermissive]
     return OpaqueJSString::create(StringImpl::createWithoutCopying(chars, numChars)).leakRef();
                                                                                   ^
In file included from ./Source/WTF/wtf/text/WTFString.h:29:0,
                 from Source/JavaScriptCore/API/OpaqueJSString.h:31,
                 from Source/JavaScriptCore/API/JSStringRef.cpp:31:
./Source/WTF/wtf/text/StringImpl.h:393:54: note:   initializing argument 1 of ‘static WTF::PassRef<WTF::StringImpl> WTF::StringImpl::createWithoutCopying(const UChar*, unsigned int)’
     WTF_EXPORT_STRING_API static PassRef<StringImpl> createWithoutCopying(const UChar* characters, unsigned length);
                                                      ^~~~~~~~~~~~~~~~~~~~
Source/JavaScriptCore/API/JSStringRef.cpp: In function ‘const JSChar* JSStringGetCharactersPtr(JSStringRef)’:
Source/JavaScriptCore/API/JSStringRef.cpp:86:30: error: invalid conversion from ‘const UChar* {aka const char16_t*}’ to ‘const JSChar* {aka const short unsigned int*}’ [-fpermissive]
     return string->characters();
            ~~~~~~~~~~~~~~~~~~^~
make[1]: *** [GNUmakefile:70161: Source/JavaScriptCore/API/libjavascriptcoregtk_1_0_la-JSStringRef.lo] Error 1
make[1]: *** Waiting for unfinished jobs....
mv -f Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSScriptRef.Tpo Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSScriptRef.Plo
mv -f Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSObjectRef.Tpo Source/JavaScriptCore/API/.deps/libjavascriptcoregtk_1_0_la-JSObjectRef.Plo
libtool: link: x86_64-pc-linux-gnu-ar cruT [long list of objects]
libtool: link: x86_64-pc-linux-gnu-ranlib .libs/libWebCore.a
libtool: link: ( cd ".libs" && rm -f "libWebCore.la" && ln -s "../libWebCore.la" "libWebCore.la" )
make[1]: Leaving directory '/var/tmp/portage/net-libs/webkit-gtk-2.4.11-r200/work/webkitgtk-2.4.11'
make: *** [GNUmakefile:25837: all] Error 2

I would love to get rid of webkit-gtk, but unfortunately can't.

As a workaround, I can extract the required libs from the icu-58.2-r1 binpkg I built, but I would prefer to not have non-ebuild libraries in the system.
Back to top
View user's profile Send private message
Princess Nell
l33t
l33t


Joined: 15 Apr 2005
Posts: 738

PostPosted: Sun Dec 10, 2017 9:40 pm    Post subject: Reply with quote

Looks like a known problem ... https://forums.gentoo.org/viewtopic-t-1073510.html. I'll know in about 90 minutes if the solution helps here.
Back to top
View user's profile Send private message
tnt
Veteran
Veteran


Joined: 27 Feb 2004
Posts: 1171

PostPosted: Mon Dec 11, 2017 2:19 pm    Post subject: Reply with quote

Wait, so this issue was officially tracked from June and still not fixed before Profile 13.0 to 17.0 change, no matter solutions were offered?
_________________
gentoo user
Back to top
View user's profile Send private message
nerdboy
n00b
n00b


Joined: 07 Oct 2012
Posts: 3
Location: California

PostPosted: Thu Jan 18, 2018 7:14 am    Post subject: (insecure) webkit-gtk requires ICU-58 Reply with quote

Maybe a better question is why this version is still available at all, or at least why isn't it limited to something less risky like eclipse java-doc rendering. Anything using it directly on the intarweb is hanging your a** out for public viewing (or worse). I can't answer your original question without asking the maintainer (and my bandwidth is negative-zero right now). If you want you can check the package metadata for webkit and query the maintainer about dependency handling and security issues. Not trying to be wonky, but I will say it's absolutely useless to argue with my wife... Oh wait, that only affects me...
Back to top
View user's profile Send private message
fedeliallalinea
Bodhisattva
Bodhisattva


Joined: 08 Mar 2003
Posts: 20126
Location: here

PostPosted: Thu Jan 18, 2018 7:32 am    Post subject: Re: (insecure) webkit-gtk requires ICU-58 Reply with quote

nerdboy wrote:
Maybe a better question is why this version is still available at all, or at least why isn't it limited to something less risky like eclipse java-doc rendering.

Some packages requires yet this version
https://bugs.gentoo.org/629114
https://bugs.gentoo.org/627554
_________________
Questions are guaranteed in life; Answers aren't.
Back to top
View user's profile Send private message
jesnow
Guru
Guru


Joined: 26 Apr 2006
Posts: 566

PostPosted: Tue Feb 20, 2018 3:05 am    Post subject: Reply with quote

I beat me head against this for days, and even did a world rebuild. Finally what worked was this:

Code:
# emerge -c webkit-gtk


Done.
Back to top
View user's profile Send private message
dalu
Guru
Guru


Joined: 20 Jan 2003
Posts: 487

PostPosted: Mon Apr 30, 2018 1:30 pm    Post subject: Reply with quote

Let me rephrase that:

Is this the webkit-gtk that is talked about here?
https://sourcegraph.com/github.com/sourcegraph/go-webkit2/-/blob/README.md
Back to top
View user's profile Send private message
fedeliallalinea
Bodhisattva
Bodhisattva


Joined: 08 Mar 2003
Posts: 20126
Location: here

PostPosted: Mon Apr 30, 2018 1:37 pm    Post subject: Reply with quote

dalu wrote:
Is this the webkit-gtk that is talked about here?
https://sourcegraph.com/github.com/sourcegraph/go-webkit2/-/blob/README.md

I think no, other version of webkit-gtk have been removed
Code:
commit c99899dde7c6c94f8ad09a1b4972f4da0d9dfdc2
Author: Mart Raudsepp <leio@gentoo.org>
Date:   Sun Mar 25 22:04:12 2018 +0300

    net-libs/webkit-gtk: Remove security vulnerable SLOT=2 and SLOT=3
   
    These slots are years old, unmaintained and vulnerable to hundreds of
    bugs with a CVE assigned. Additionally there are some known unfixed
    issues building against newer ICU. No interest in continued maintenance
    of known hugely security vulnerable versions, thus with no consumers
    remaining in main tree, this is going away now. Sorry.
    If you need this, please think seriously ten times before you make it
    available to yourself via an overlay, or use any software that requires
    this security riddled version still.
   
    Closes: https://bugs.gentoo.org/577068

_________________
Questions are guaranteed in life; Answers aren't.
Back to top
View user's profile Send private message
dalu
Guru
Guru


Joined: 20 Jan 2003
Posts: 487

PostPosted: Mon Apr 30, 2018 6:43 pm    Post subject: Reply with quote

Ok I guess it is the same, only that latest stable is 2.20.1 and this is at 2.18.6 now.
And <2.20 have security advisories, so this should be bumped.
https://webkitgtk.org/security/WSA-2018-0003.html
Back to top
View user's profile Send private message
Display posts from previous:   
Reply to topic    Gentoo Forums Forum Index Portage & Programming All times are GMT
Page 1 of 1

 
Jump to:  
You cannot post new topics in this forum
You cannot reply to topics in this forum
You cannot edit your posts in this forum
You cannot delete your posts in this forum
You cannot vote in polls in this forum